#include "stdafx.h"
#include "AutoPSA.h"
#include "FileDialogEx.h"

#include "AutoPSAINDoc.h"
#include "AutoPSAINView.h"
#include "AutoPSA.h"
#include "StaticAnalysis.h"
#include "autopsaintabview.h"
#include "tabpage1.h"

#include "MainFrm.h"
#include "CntrItem.h"
#include <fstream.h>
#include <math.h>
#include <IOMANIP.H>
#include "ChildINFrm.h"
#include "math.h"

#include "DlgDynamicAnalysis.h"

#include "PipeStruct/OutFunction.h"
#include "PipeFEM.h"
#include "OutPSA70Data.h"
#include "AnalysisResult.h"
#include"OutPoint.h"
#include "drawinview.h"
#include "user.h"

#include "UndergroundFactory.h"

/*
	ܣĵ(GLIFV3.0ŵĵ)زGLIFV3.0Ӧĵ
	ߣchenbailian
*/


int CAutoPSAInDoc::GetGLifOrNotGLifNodeNumber(int nNodeNumber)
{
	POSITION pos;
	GLifNumberConnection *pGLifNumberConnectionData;//GLIFV3.0ͲGLIFV3.0ʽŶӦϵݽṹ
		//GLIFV3.0ʽţݰGLIFV3.0ʽŵĺŵҳӦGLIFV3.0ʽŵĵ
		//cbl 04.3.17
		pos = mGLifNumberConnectionList.GetHeadPosition();
		while(pos)
		{
			pGLifNumberConnectionData = mGLifNumberConnectionList.GetNext(pos);
			if(pGLifNumberConnectionData->nGLifNodeNum == nNodeNumber)
			{
				return pGLifNumberConnectionData->nPSANodeNum;
				
			}
		}
}

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *       
//    :             ־                                                                        *
//    :                                                                                         *?

                                                                      
//          MatrixDecompose?                                                                                     *
//    :                            
//          ֽ?                                                                                                       *
//                                                                                                    *
//    ó:                          ?                                                    *
//          AnalysisByWorkDuty                                                                 *
//    ó:                                                                                                  *
//                                                                                       *
//    ȡļ:                                                                                *
//                                                                                       *
//    дļ:                                                                                *
//                                                                                       *
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

bool CAutoPSAInDoc::MatrixDecompose(int &NF0,int &JSIX,double DJX[],int JYS[],int IDJX[],double ZK[])
{
	//ֽ
	int I,J;
	int K;
	double SUM;
	double Z;
	int JMIN,JJJJJ,JXMIN,JJ,IJ,JX;
	for( I=1;I<=JSIX;I++)
		DJX[I]=1.0;
/*#ifdef _DEBUG
	ofstream filedbg("C:\\ZK1.txt");
	CString strdbg;
	for(I=1;I<=NF0;I++)
	{
		strdbg.Format(_T("ZK[%d]=%10.5f\n"),I,ZK[I]);
		filedbg<<strdbg;
	}
	filedbg.close();
	filedbg.open("C:\\JYS1.txt");
	for(I=1;I<=JSIX;I++)
	{
		strdbg.Format(_T("JYS[%d]=%d\n"),I,JYS[I]);
		filedbg<<strdbg;
	}
	filedbg.close();
#endif*/

	for(I=1;I<=JSIX;I++)
	{
		JMIN=I-JYS[I];
		K=IDJX[I];
		Z=ZK[K];
		//TRACE("I=%d , JMIN=%d , K = %d , Z = %f\n",I,JMIN,K,Z);
		for(J=JMIN;J<=I;J++)
		{
			IJ=K-I+J;
			SUM=ZK[IJ];
			JJJJJ=J-JMIN;
			JXMIN=min(JYS[J],JJJJJ);
			//TRACE("\tIJ=%d , SUM=%f , JJJJJ =%d , JXMIN = %d\n",IJ,SUM,JJJJJ,JXMIN);
			if(JXMIN==0)
				;
			else
			{
				JJ=IDJX[J];
				for( JX=1;JX<=JXMIN;JX++)
					SUM=SUM-ZK[IJ-JX]*ZK[JJ-JX]*DJX[J-JX];
			}
			if(DJX[J]==0.0)
			{   
				//TRACE(_T("I=%d, J= %d ,DJX[J]=%f\n"),I,J,DJX[J]);
				strInfo.LoadString(IDS_ZEROELEMENT);
				(*file1)<<strInfo;
				strInfo.LoadString(IDS_ELEMENTZERO);
				OutMsg(strInfo);
				//AfxMessageBox(IDS_ELEMENTZERO);
				return false;
			}
			ZK[IJ]=SUM/DJX[J];
		}
		DJX[I]=ZK[IJ];
		ZK[IJ]=1.0;
	}
	return true;
}

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//    :             ־                                                                        *
//    :                                                                                         *?

//           SetBoundConditionGeneral                                                                 *
//    :                         ?                                                              *
//           ͨñ߽              ?                                    *
//    ó:                          ?                                                    *
//           AnalysisByWorkDuty                                                                         *
//    ó:                                                                                      *
//           ?                                                                         *
//    ȡļ:                                                                                *
//           ?                                                                         *
//    дļ:                                                                                *
//           ?                                                                         *
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
void CAutoPSAInDoc::SetBoundConditionGeneral(int &JSIX,int &NF0,int &iNumElements,int nNodeType[],double ZK[],int mEndPoint[],int IDJX[],int &ncdh,int jctab[])
{	
	double fRigidityOfPHS;//֧ܸնȷΣô
	fRigidityOfPHS=pow(10.0,ZDFC);
	double W[7];
	int iPointEnd,nPointStartEnd,iNodeType,IH,JH,IJ;
	int i,IU,IW;
	int ijhd,IFZ;
	int I,J;
	for(IFZ=1;IFZ<=iNumElements;IFZ++)    //100 IFZ=1,iNumElements
	{
		iPointEnd=mEndPoint[IFZ];
		nPointStartEnd=jctab[iPointEnd];
		iNodeType=nNodeType[IFZ];
		if(iCoolStatusHange2Zero<1 )
		{
			if(iNodeType<80 && (IGK==1 || IGK==100))
			{
				iNodeType=iNodeType+100;
			}
			else if(iNodeType<80 && (IGK!=1 && IGK!=100))
			{
				iNodeType=100;
			}
			
			if(iPointEnd==0||iNodeType==100 || iNodeType==98||(iNodeType>200 && iNodeType<300)) continue;//GOTO 100;
			if(iNodeType>300 && iNodeType<400) continue;   //GOTO 100;
			if(iNodeType==91&&IGK==1)
			{
				nNodeType[IFZ]=81;
				continue;						//GOTO 100;
			}else if(iNodeType==92 && IGK==1)
			{
				nNodeType[IFZ]=82;
				continue;						//GOTO 100;
			}else if(iNodeType==94 && IGK==1)
			{
				nNodeType[IFZ]=84;
				continue;						//GOTO 100;
			}
		}else if( iCoolStatusHange2Zero>=1 )
		{
			if(iNodeType<80 && (IGK==0))
			{
				iNodeType=iNodeType+100;
			}else if(iNodeType<80&&IGK!=0)
			{
				iNodeType=100;
			}
			if(iPointEnd==0||iNodeType==100 || iNodeType==98 || (iNodeType>200 && iNodeType<300)) 
				continue;						//GOTO 100;
			if(iNodeType>300&&iNodeType<400) 
				continue;						//GOTO 100;
			
			if(iNodeType==91&&IGK==0)
			{
				nNodeType[IFZ]=81;
				continue;						//GOTO 100;
			}else if(iNodeType==92&&IGK==0)
			{
				nNodeType[IFZ]=82;
				continue ;						//GOTO 100;
			}else if(iNodeType==94&&IGK==0)
			{
				nNodeType[IFZ]=84;
				continue;						//GOTO 100;
			}
		}				
		if(IGK!=100&&iNumGivenSpringLoadPoints>0 && (iNodeType>80&&iNodeType<=99))
		{
			BOOL bContinue=FALSE;
			for(ijhd=1;ijhd<=iNumGivenSpringLoadPoints;ijhd++)   //111 ijhd=1,iNumGivenSpringLoadPoints
			{
				if(nPointStartEnd==nPointGivenSpringLoad[ijhd])
				{
					bContinue=TRUE;
					break;
				}//goto 100;
			}
			if(bContinue) continue;
		}
		for(I=1;I<=6;I++)
			W[I]=0.0;
		IH=0;//λԼ־
		JH=0;//λԼ־
		if(iNodeType>80 && iNodeType<=94 || iNodeType>1000 || iNodeType==99)
		{
			//Լ
			if(IGK==1 && iCoolStatusHange2Zero< 1 ) W[giUPxyz]=fRigidityOfPHS;
			if(IGK==0 && iCoolStatusHange2Zero>=1 ) W[giUPxyz]=fRigidityOfPHS;
			if(IGK==100) W[giUPxyz]=fRigidityOfPHS;
		}else
		{
			//ǵԼ
			IU=iNodeType-100;
			i=IU/10;//λԼ
			IW=IU-i*10;//λԼ
			for(I=1;I<=7;I++)
			{
				if(i==I)
				{
					JH=1;//ҵλԼ
					if(I==1||I==4||I==5||I==7) W[1]=fRigidityOfPHS;
					if(I==2||I==4||I==6||I==7) W[2]=fRigidityOfPHS;
					if(I==3||I==5||I==6||I==7) W[3]=fRigidityOfPHS;
				}
				if(IW==I)
				{
					IH=1;//ҵλԼ
					if(I==1||I==4||I==5||I==7) W[4]=fRigidityOfPHS;
					if(I==2||I==4||I==6||I==7) W[5]=fRigidityOfPHS;
					if(I==3||I==5||I==6||I==7) W[6]=fRigidityOfPHS;
				}
				if(JH==1&&IH==1) break;
			}
		}
		
		for(I=1;I<=6;I++)
		{
			J=6*(iPointEnd-1)+I;
			IJ=IDJX[J];
			ZK[IJ]=ZK[IJ]+W[I];
		}
	}
	return;    
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//    :             ־                                                                        *
//    :                                                                                         *?

//           SetBoundConditionForWorkDuty9                                                                 *
//    :                         ?                                                              *
//          ?5 6 8 浯ɸն  ?                                    *
//    ó:                          ?                                                    *
//           AnalysisByWorkDuty                                                                         *
//    ó:                                                                                      *
//           ?                                                                         *
//    ȡļ:                                                                                *
//           ?                                                                         *
//    дļ:                                                                                *
//           ?                                                                         *
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
void CAutoPSAInDoc::SetBoundConditionForWorkDuty9(int &NF0,int &iNumElements,int &NCDH,int &JSIX,int nEndPoint[],int nOutputNodeType[],double ZK[],int IDJX[],double fSpringFlexibilityCoef[][51],int nSpringType[])
{
	int mOutputNodeType;//ڵ,غΪ9999غΪ5000ԼΪɺ
	int iSpringSeriesNum;//ɴ
	int iParellelSpringNum;//ɲ
	int iSpringIndex;//ɺ
	int mSpringType;//
	double TG;//
	
	int IJ;
	int i;
	int J;//ĩ
	int IFZ;//Ԫ
	
	
	for(IFZ=1;IFZ<=iNumElements;IFZ++)      
	{
		mSpringType=nSpringType[IFZ];
		J=nEndPoint[IFZ];
		if(J==0)  
			continue;      //GOTO 1000;
		mOutputNodeType=nOutputNodeType[J];
		if(mOutputNodeType==0||(mOutputNodeType==9999||mOutputNodeType==8888)) 
			continue;     //GOTO 1000;
		iSpringSeriesNum=mOutputNodeType/1000;
		iParellelSpringNum=(mOutputNodeType/100) % 10;
		iSpringIndex=mOutputNodeType % 100;
		TG=fSpringFlexibilityCoef[mSpringType][iSpringIndex];
		if(iSpringSeriesNum==0||(mOutputNodeType==9999||mOutputNodeType==8888))
		{
			continue;   //GOTO 1000
		}
		i=(J-1)*6+giUPxyz;
		IJ=IDJX[i];//ԽԪ
		ZK[IJ]=ZK[IJ]+1.0/TG/iSpringSeriesNum*iParellelSpringNum;//ܸվZK

	}
	return ;

}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//    :             ־                                                                        *
//    :                                                                                         *?

//           SetBoundConditionForWorkDuty9                                                                 *
//    :                         ?                                                              *
//          ?9 ɸ             ?                                    *
//    ó:                          ?                                                    *
//           AnalysisByWorkDuty                                                                         *
//    ó:                                                                                      *
//           ?                                                                         *
//    ȡļ:                                                                                *
//           ?                                                                         *
//    дļ:                                                                                *
//           ?                                                                         *
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
void CAutoPSAInDoc::SetBoundConditionFor1(int &NF0,int &iNumElements,int &JSIX,int nEndPoint[],double ZK[],int IDJX[],int nNodeType[])
{
	int J,I,IJ;
	int iNodeType;
	double fRigidityOfPHS,W;
	fRigidityOfPHS=pow(10.0,ZDFC);
	for(int IFZ=1;IFZ<=iNumElements;IFZ++)
	{
		J=nEndPoint[IFZ];
		iNodeType=nNodeType[IFZ];
		if(J==0)
			continue;              //GOTO 1000
		if(iNodeType>80 && iNodeType<=99||iNodeType>=1000)
		{
			W=fRigidityOfPHS;
		}else if(iNodeType==199)
		{			
			W=fRigidityOfPHS;
		}else
		{
			continue;              //GOTO 1000
		}
		I=(J-1)*6+giUPxyz;
		IJ=IDJX[I];
		ZK[IJ]=ZK[IJ]+fRigidityOfPHS;
		//	1000    CONTINUE
	}
	return ;
}

	    

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//    :             ־                                                                        *
//    :                                                                                         *?

//           SetBoundConditionForWorkDuty3                                                                 *
//    :                         ?                                                              *
//          ?ڸõ֧                             *
//    ó:                          ?                                                    *
//           AnalysisByWorkDuty                                                                         *
//    ó:                                                                                      *
//           ?                                                                         *
//    ȡļ:                                                                                *
//           ?                                                                         *
//    дļ:                                                                                *
//           ?                                                                         *
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
void CAutoPSAInDoc::SetBoundConditionForWorkDuty3(int &JSIX,int &NF0,int &iNumElements,int nNodeType[],double ZK[],int mEndPoint[],int IDJX[])
{
	double fRigidityOfPHS;
	double W[7];
	int  iPointEnd;
	int  iNodeType;
	int  IH,JH;
	int  IU,i,IW;
	int  J,IJ;
	
	fRigidityOfPHS=pow(10.0,ZDFC);
	
	for(int IFZ=1;IFZ<iNumElements;IFZ++)   //100 IFZ=1,iNumElements
	{
		iPointEnd=mEndPoint[IFZ];
		iNodeType=nNodeType[IFZ];
		for(int I=1;I<=6;I++)
			W[I]=0.;
		IH=0;
		JH=0;
		if(iNodeType>300 && iNodeType<400)
		{
			IU=iNodeType-300;
			i=IU/10;
			IW=IU-i*10;
			for(I=1;I<=7;I++)
			{
				if(i==I)
				{
					JH=1;
					if(I==1||I==4||I==5||I==7) W[1]=fRigidityOfPHS;
					if(I==2||I==4||I==6||I==7) W[2]=fRigidityOfPHS;
					if(I==3||I==5||I==6||I==7) W[3]=fRigidityOfPHS;
				}
				if(IW==I)
				{
					IH=1;
					if(I==1||I==4||I==5||I==7) W[4]=fRigidityOfPHS;
					if(I==2||I==4||I==6||I==7) W[5]=fRigidityOfPHS;
					if(I==3||I==5||I==6||I==7) W[6]=fRigidityOfPHS;
				}
				if(JH==1&&IH==1) break ;   //GOTO 60;   
			}
		}

		//60
		for(I=1;I<=6;I++)
		{
			J=6*(iPointEnd-1)+I;
			IJ=IDJX[J];
			ZK[IJ]=ZK[IJ]+W[I];
		}
	}
	return ;
}

void CAutoPSAInDoc::InitStaticVarible()
{
	iHas5=0;   
	iHas6=0;    
	iHas7=0;   
	iHas8=0;   
	iHas9=0;    
	iHas10=0;
	ZK=NULL;
	//s_hZK=NULL;
	IS=0;
	IE=0;
	IA=0;
}
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//*    :                                              *
//*                FormatOutputStressData                                  *
//*    :                                                *
//*                ԼӦ               *
//*    ó:                                          *
//*                VNEW11                                   *
//*    ó:                                            *
//*                OutputPageTitle                                   *
//*    ȡļ:                                            *
//*            ļ                                   *
//*            18          ԪӦ                         *
//*    дļ:                                            *
//*            ļ                                   *
//*            23          ݿļ(61,62)                *
//*            1                                *
//*                                                         *
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//*    ޸Ļ                                           *
//*    :                                              *
//*    :                                            *
//*    :                                            *
//*                                                         *
//*                                                         *
//*                                                         *
 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
void CAutoPSAInDoc::FormatOutputStressData(int IJ)
{
	int aIPipeNo[4001]={0},IGK1[4001]={0},IS1[4001]={0},IM1[4001]={0},MIJ1[4001]={0};
	double FJQ1[4001]={0.0},aCoefStress1[4001]={0.0};
	double aXMM1[4001]={0.0},aXMAT1[4001]={0.0},aXMAD1[4001]={0.0},aXMT1[4001]={0.0};
	double tj1[4001]={0.0},t01[4001]={0.0},pj1[4001]={0.0},dw1[4001]={0.0},S1[4001]={0.0};
	int IGZ[801]={0},IGK[801]={0},IS[801]={0},IM[801]={0},MIJ[801]={0};
	double FJQ[801]={0.0},aCoefStress[801]={0.0},aXMM[801]={0.0},aXMAT[801]={0.0},aXMAD[801]={0.0},aXMT[801]={0.0};
	TCHAR ok[801][7]={0};
	CString mstrOutputUnit;
	CString strOut;
	int i,j,k,ijk,kk,nc1,nc2,ngd1;
	double rmij;

	/////////////////////////////////
	
	//õͼ
	CView * pView=GetActiveView();
	POSITION pos=this->GetFirstViewPosition();
	while(pos!=NULL)
	{
		pView=this->GetNextView(pos);
		if(pView->IsKindOf(RUNTIME_CLASS(CAutoPSAInTabView)))	
			break;
	}
	int nNotGlifNumberForm,nNotGlifNumberEnd;//Ľ
	/////////////////////////////////

	if(iUnitOutput==1)
	{
		mstrOutputUnit="[kgf/cm**2]";
	}else
	{
		mstrOutputUnit="[MPa]";
	}
 
	IJ=0;
	//ͷ
	OutputPageTitle(1);
	//Ӧ
	strOut.Format("\n\n%29.29sTOTAL MAX STRESS TABLE\n\n"," ");
	(*file1)<<strOut;
	strOut.Format("%70.70s%12.12s\n\n"," ",mstrOutputUnit);
	(*file1)<<strOut;
	strOut.Format("   No  CASE    START%7.7sEND   IJ     i     f/k%7.7sSTRESS-C     STRESS-A\n\n"," "," ");
	(*file1)<<strOut;
	//open(unit=18,file='fort18',status='old')
	(*file18).seekg(0);
	iNumElements=0;
//	ofstream fdbg("c:\\f18.txt");
	for( i=1;(i<=MAX_ELEMENTS_NUM) && (!file18->IsEof());i++)
	{
		iNumElements++;
		READ16((*file18),aIPipeNo[i],IGK1[i],IS1[i],IM1[i],MIJ1[i],FJQ1[i],aCoefStress1[i],aXMM1[i],aXMAT1[i],aXMAD1[i],aXMT1[i],tj1[i],t01[i],pj1[i],dw1[i],S1[i])

	//	CString strdbg;
	//	strdbg.Format("\n%4d%6d%6d%6d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f",aIPipeNo[i],IGK1[i],IS1[i],IM1[i],aXMT1[i],tj1[i],t01[i],pj1[i],dw1[i],S1[i]);
	//	fdbg<<strdbg;
		/*
		CString strdbg;
		strdbg.Format("\n%4d%4d%4d%4d%4d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f",aIPipeNo[i],IGK1[i],IS1[i],IM1[i],MIJ1[i],FJQ1[i],aCoefStress1[i],aXMM1[i],aXMAT1[i],aXMAD1[i],aXMT1[i],tj1[i],t01[i],pj1[i],dw1[i],S1[i]);
		fdbg<<strdbg;*/
	}
	//fdbg.close();
	if(iNumElements>MAX_ELEMENTS_NUM)
	{
		OutMsg("Sorry.\n");
		OutMsg("The cases or elements is too many.");
		OutMsg("Remove some cases or elements.");
	}
	k=0;
	ijk=0;
	//fdbg.open("c:\\f19.txt");
	for(i=1;i<=iNumElements;i++)
	{
		//aIPipeNo[i]ܵţӦڹܵPIPE PARAMETERSµNo,ͬĹܾںһӦıNo.
		nc1=aIPipeNo[i];
		if(aIPipeNo[i]!=0)
		{
			if(i>=2)
			{
				if(IGK1[i]!=IGK1[i-1]) k=0;
			}
			//MAX_PIPE_NO=65ֹܵ
			if(nc1==MAX_PIPE_NO)
			{
				kk=555;
			}else
			{
				//ܵNoΪ1ʼȻ
				k++;
			}
			ijk++;  
			for(j=1;j<=iNumElements;j++)
			{
				if(aIPipeNo[j]!=0)
				{
					nc2=aIPipeNo[j];
					if(dw1[i]==dw1[j]&&S1[i]==S1[j]&&tj1[i]==tj1[j]&&t01[i]==t01[j]&&pj1[i]==pj1[j]&&(aXMT1[i]==aXMT1[j])&&IGK1[i]==IGK1[j])
					{
						aIPipeNo[j]=0;
						if((aXMAD1[j] - aXMAD[ijk] > 0.00001) && ( aXMT1[j]-aXMAD1[j] > 0.00001))
						//if((aXMAD1[j] > aXMAD[ijk]) && ( aXMT1[j]>aXMAD1[j]))
						{
							if(nc2==MAX_PIPE_NO)
								IGZ[ijk]=kk;
							else														
								IGZ[ijk]=k;      				  
							IGK[ijk]=IGK1[j];
							IS[ijk]=IS1[j];
							IM[ijk]=IM1[j];
							MIJ[ijk]=MIJ1[j];
							FJQ[ijk]=FJQ1[j];
							aCoefStress[ijk]=aCoefStress1[j];
							aXMM[ijk]=aXMM1[j];
							aXMAT[ijk]=aXMAT1[j];
							aXMAD[ijk]=aXMAD1[j];
							aXMT[ijk]=aXMT1[j];
							strcpy(&ok[ijk][0],"-ok-");
							//CString strdbg;
							//strdbg.Format("\n1    %4d%4d%4d%4d%4d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f %s",
							//	IGK[ijk],IS[ijk],IM[ijk],IM1[i],MIJ[ijk],FJQ[ijk],
							//	aCoefStress[ijk],aXMM[ijk],aXMAT[ijk],aXMAD[ijk],aXMT[ijk],&ok[ijk][0]);
							//fdbg<<strdbg;
						}else if( aXMAD1[j]-aXMT1[j] > 0.00001 || fabs(aXMAD1[j]-aXMT1[j]) < 0.00001)
						{
							if(nc2==MAX_PIPE_NO)
								IGZ[ijk+1]=kk;
							else
								IGZ[ijk+1]=k;

							IGK[ijk+1]=IGK[ijk];
							IS[ijk+1]=IS[ijk];
							IM[ijk+1]=IM[ijk];
							MIJ[ijk+1]=MIJ[ijk];
							FJQ[ijk+1]=FJQ[ijk];
							aCoefStress[ijk+1]=aCoefStress[ijk];
							aXMM[ijk+1]=aXMM[ijk];
							aXMAT[ijk+1]=aXMAT[ijk];
							aXMAD[ijk+1]=aXMAD[ijk];
							aXMT[ijk+1]=aXMT[ijk];
							memcpy(&ok[ijk+1][0],&ok[ijk][0],7);

							if(nc2==MAX_PIPE_NO)
								IGZ[ijk]=kk;
							else
								IGZ[ijk]=k;

							IGK[ijk]=IGK1[j];
							IS[ijk]=IS1[j];
							IM[ijk]=IM1[j];
							MIJ[ijk]=MIJ1[j];
							FJQ[ijk]=FJQ1[j];
							aCoefStress[ijk]=aCoefStress1[j];
							aXMM[ijk]=aXMM1[j];
							aXMAT[ijk]=aXMAT1[j];
							aXMAD[ijk]=aXMAD1[j];
							aXMT[ijk]=aXMT1[j];
							strcpy(&ok[ijk][0],"****");

							ijk++;
							//CString strdbg;
							//strdbg.Format("\n2   %4d%4d%4d%4d%4d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f %s",
							//	IGK[ijk],IS[ijk],IM[ijk],IM1[i],MIJ[ijk],FJQ[ijk],
							//	aCoefStress[ijk],aXMM[ijk],aXMAT[ijk],aXMAD[ijk],aXMT[ijk],&ok[ijk][0]);
							//fdbg<<strdbg;
						}
					}
				}
			}
			aIPipeNo[i]=0;
		}
	}
	//fdbg.close();
	if(ijk>800)
	{
		OutMsg("**** Sorry    ****\r\n");
		OutMsg("**** The element illegal stress is too many.\r\n");
		OutMsg("**** to check data carefully.\r\n");
		(*file1)<<"****    Sorry    ****\n";
		(*file1)<<"**** The element illegal stress is too many.\n";
		(*file1)<<"**** to check data carefully.\n";
	}
	for(i=1;i<=ijk;i++)
	{
		if(IGZ[i]>0&&IGK[i]>0)
		{
			if(!m_bElementNumByGLIFv31)
			{
				//GLIFV3.0ʽţݰGLIFV3.0ʽŵĺŵҳӦGLIFV3.0ʽŵĵ
				//cbl 04.3.17
				nNotGlifNumberForm = GetGLifOrNotGLifNodeNumber(IS[i]);
				nNotGlifNumberEnd = GetGLifOrNotGLifNodeNumber(IM[i]);
				
			}
			else
			{
				nNotGlifNumberForm = IS[i];
				nNotGlifNumberEnd = IM[i];
			}
			
			strOut.Format("%5d%5d%10d%10d%5d%8.3f%7.3f%13.3f%13.3f%6.6s\n",IGZ[i],IGK[i],nNotGlifNumberForm,nNotGlifNumberEnd,MIJ[i],FJQ[i],aCoefStress[i],aXMAD[i],aXMT[i],&ok[i][0]);
			(*file1)<<strOut;
			if(iOutputFileTag==2)
			{
				ngd1=61;
				strOut.Format("%5d%7d%7d%15.3f%15.3f%15.3f%15.3f%15.3f%15.3f %13.13s %13.13s\n",ngd1,IS[i],IM[i],FJQ[i],aCoefStress[i],aXMM[i],aXMAT[i],aXMAD[i],aXMT[i],&ok[i][0],&ok[i][0]);
				(*file23)<<strOut;
				ngd1=62;
				rmij=MIJ[i];
				strOut.Format("%5d%7d%7d%15.3f%15.3f%15.3f%15.3f%15.3f%15.3f %13.13s %13.13s\n",ngd1,IGZ[i],IGK[i],rmij,rmij,rmij,rmij,rmij,rmij,&ok[i][0],&ok[i][0]);
				(*file23)<<strOut;		
			}else if(iOutputFileTag==1)
			{
				ngd1=61;
				strOut.Format("%5d%5d%10d%10d%15.3f%15.3f%15.3f%15.3f%15.3f%15.3f\n",ngd1,ngd1,IS[i],IM[i],FJQ[i],aCoefStress[i],aXMM[i],aXMAT[i],aXMAD[i],aXMT[i]);
				(*file23)<<strOut; 
				ngd1=62;
				rmij=MIJ[i];
				strOut.Format("%5d%5d%10d%10d%15.3f%15.3f%15.3f%15.3f%15.3f%15.3f\n",ngd1,ngd1,IGZ[i],IGK[i],rmij,rmij,rmij,rmij,rmij,rmij);
				(*file23)<<strOut;
			}else if(iOutputFileTag==3)
			{
				ngd1=61;
				strOut.Format("%12d%12d%12d%12d%12d%12.3f%12.3f%12.3f%12.3f%12.3f\n",ngd1,IGK[i],IS[i],IM[i],MIJ[i],FJQ[i],aCoefStress[i],aXMM[i],aXMAT[i],aXMAD[i]);
				(*file50)<<strOut;      	        	  
				ngd1=62;
				rmij=MIJ[i];
				strOut.Format("%12d%12d%12d%12d%12d%12.3f%12.3f%12.3f%12.3f%12.3f\n",ngd1,IGZ[i],IGZ[i],IGZ[i],IGZ[i],aXMT[i],aXMT[i],aXMT[i],aXMT[i],aXMT[i]);
				(*file50)<<strOut;      	        	  				
			}
		}
	}
	strOut.Format("\n%28.28s------END OF THE REPORT------\n"," ");
	(*file1)<<strOut;  
}
CView* CAutoPSAInDoc::GetActiveView()
{
	CFrameWnd* pFrameWnd=((CFrameWnd*)AfxGetMainWnd())->GetActiveFrame();
	CView* pView=(pFrameWnd)->GetActiveView();
	if(pView && pView->GetDocument()==this)
	{
		CWnd* pWnd=pView->GetParent();
		if(pWnd && pWnd->IsKindOf(RUNTIME_CLASS(CView)))
			return (CView*)pWnd;
		return pView;
	}
	return NULL;
}
extern CString strCodeDesc[10][2];
void CAutoPSAInDoc::OnSastatic70() 
{
	
	// TODO: Add your command handler code here
	CPipeUnitData* pUnitData = NULL;
	BOOL bSoildModalTag = FALSE;
	POSITION pos;

	if( m_GlobalData->m_bSoid )
	{
		pos = m_listPipeUnit->GetHeadPosition();
		while (pos)
		{
			pUnitData = m_listPipeUnit->GetNext( pos );
			
			if ( pUnitData->m_SoilModels.m_bSoilModelsTag )
			{
				bSoildModalTag = TRUE;
				break;
			}
		}
	}

	if ( bSoildModalTag )
	{
		OnTransformSoilModel();	
	}
	

	DeleteLastPipeUnit(m_listPipeUnit,this);//ɾͶӰȫΪĵԪ2007-04-23lyf
	
	this->OnFileSave();
	CString strFilePath;
	CString strCaseFileName;

	::m_strFileNameIn=this->GetPathName();
	if(::m_strFileNameIn.IsEmpty() )
		return;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strCaseFileName=strFilePath+".sta";
	
	CArray<CString,CString> TempArray;
	
	//õϵгֹй(:H;,ˮѹ,,¶,ѹ,/,,λ)
	GetAllCaseLoadCode(TempArray,m_listPipeUnit);
	CStaticAnalysis SAnalysisDlg;
	SAnalysisDlg.m_strFileName=strCaseFileName;
	SAnalysisDlg.pCaseLoadArray = &TempArray;
	SAnalysisDlg.m_Page1.m_iHangerMCaseNumer = m_GlobalData->m_InitHangerAtt.m_iInitIdfoper;
	if( SAnalysisDlg.DoModal() == 1) //ʾ
	{
		CString strTemp;
		//Ϣ
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.m_FlatTabCtrl.SetCurSel(1);
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.SelectTabView(1);
		((CMainFrame*)AfxGetMainWnd())->ShowControlBar(&((CMainFrame*)AfxGetMainWnd())->m_wndOutput,TRUE,FALSE);
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.UpdateWindow();

		strTemp = GetResStr(IDS_CHECK_DATUM);
		OutMsg(strTemp);
		CArray<CString,CString> mErrArray;
		CArray<CString,CString> mWarningArray;
		CheckDataError(mErrArray,mWarningArray,m_listPipeUnit,m_GlobalData,gRefInfoCon,gMaterialCon,::m_strFileNameIn);
		int iSize = mErrArray.GetSize();
		for(int i=0;i<iSize;i++)
		{
			strTemp = mErrArray.GetAt(i);
			OutMsg(strTemp);
		}
		if(iSize > 0)
		{
			strTemp = GetResStr(IDS_INPUT_CALCULATE_FAILED);
			OutMsg(strTemp);
			return;
		}
		iSize = mWarningArray.GetSize();
		for( i=0;i<iSize;i++)
		{
			strTemp = mWarningArray.GetAt(i);
			OutMsg(strTemp);
		}
		if(iSize<=0)
		{
			strTemp = GetResStr(IDS_INPUT_OK);
			OutMsg(strTemp);
		}
		else
		{
			if( AfxMessageBox(GetResStr(IDS_ALARM_EXIST),MB_YESNO) != IDYES)
			{
				strTemp = GetResStr(IDS_CALCULATE_FAILED);
				OutMsg(strTemp);
				return;
			}
				
		}


		CString strFileNameCmp;
		strFileNameCmp = strFilePath +".Cmp";
		
		
		if( !WriteListToCmpFile(m_listPipeUnit,m_GlobalData,strFileNameCmp,gRefInfoCon,gMaterialCon)) //дмļ
		{
			
			return;
		}
		
		CString strFileNamestrRst; //ļ
		strFileNamestrRst= strFilePath + ".staOut";		

		CPipeFEM StaticAnalysis;


		
		//ڽļдģ
		WriteDataToPSAFile(m_listPipeUnit,m_GlobalData,strFileNamestrRst,strAutoPSAVersion,strAutoPSARevision,gMaterialCon);

		CString strtime = COleDateTime::GetCurrentTime().Format(_T("%Y/%m/%d  %H:%M:%S"));
		strTemp.Format(GetResStr(IDS_BEGIN_ANALYSE_STATICS),strtime);
		OutMsg(strTemp);
		StaticAnalysis.CalcSta(gstrMatPath.GetBuffer(20),gstrSpringPath.GetBuffer(20),
		                   strFileNameCmp.GetBuffer(20),strCaseFileName.GetBuffer(20),
						   strFileNamestrRst.GetBuffer(20),gRefInfoCon);
		strtime = COleDateTime::GetCurrentTime().Format(_T("%Y/%m/%d  %H:%M:%S"));
		strTemp.Format(GetResStr(IDS_SUCCEED_ANALYSE_STATICS),strtime);
		OutMsg(strTemp);

		//GLIF3.xʽļ
/*		CString strFileNameout1;
		strFileNameout1 = strFilePath+".out1";
		CString m_strtime=COleDateTime::GetCurrentTime().Format(_T("%Y/%m/%d  %H:%M:%S"));
		COutPSA70Data OutPSA70(::m_strFileNameIn,strFileNamestrRst,strFileNameout1,m_strCodeName,m_strtime);
		OutPSA70.OutPSA70File();
	*/
		strTemp.Format(GetResStr(IDS_SPRING_SHOW_RESULTS),strFileNamestrRst);
		OutMsg(strTemp);
		WritStaOutFileToTable(strFileNamestrRst,gRefInfoCon,gSpringCon);
		CAnalysisResult Result;
		Result.m_strFileName = strFileNamestrRst;
		Result.DoModal();//			
		if( Result.m_bView)
		{
			OnViewPreview();		
			m_bTransmutate=TRUE;
			Result.m_bView=FALSE;
		}
        else m_bTransmutate=FALSE;		
		 /*CView *pView;
	     POSITION pos=this->GetFirstViewPosition();
	     while(pos)
		 {
		  pView=this->GetNextView(pos);
		  if(pView->IsKindOf(RUNTIME_CLASS(CDrawInView)))
		  {		
		  ((CDrawInView*)pView)->m_bTransmutate=TRUE;
		  //((CDrawInView*)pView)->m_bReWriteComb=TRUE;
           ((CDrawInView*)pView)->SetPipedeflective();
		   ((CDrawInView*)pView)->SetPipeList(TRUE);
            ((CDrawInView*)pView)->Invalidate;
		   break;	
		  }
		 }	*/		
    strTemp.Format( GetResStr(IDS_DIS_SHOW_FILE_SUCCEED),strFileNamestrRst);
    OutMsg(strTemp);
	m_bCaculate=TRUE;
	}	
	
}

void CAutoPSAInDoc::OnDynamicAnalisis() 
{
	DeleteLastPipeUnit(m_listPipeUnit,this);//ɾͶӰȫΪĵԪ2007-04-23lyf
	
	CDlgDynamicAnalysis dlg;	
	dlg.m_listPipeUnit = m_listPipeUnit;
	if (dlg.DoModal() == 1)
	{
		//Ϣ
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.m_FlatTabCtrl.SetCurSel(1);
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.SelectTabView(1);
		((CMainFrame*)AfxGetMainWnd())->ShowControlBar(&((CMainFrame*)AfxGetMainWnd())->m_wndOutput,TRUE,FALSE);
		((CMainFrame*)AfxGetMainWnd())->m_wndOutput.UpdateWindow();

		
		CString strFilePath,strFileNameCmp;
		strFilePath=::GetFilePath(::m_strFileNameIn);
		strFilePath+="\\";
		strFilePath+=::GetFileTitle(::m_strFileNameIn);
		strFileNameCmp = strFilePath+".Cmp";
		
		CString strFileNameSta;
		strFileNameSta = strFilePath+".sta";
		
		CString strFileNamestrRst;
		strFileNamestrRst = strFilePath+".staOut";//".staOut";
		
		CString strFileNamestrDya;
		strFileNamestrDya = strFilePath+".dyn";
		
		CString strFileNamestrDyaOut;
		if(dlg.m_iAnalysisType == 1) //ģ̬
			strFileNamestrDyaOut = strFilePath+".dynOutM";
		else if( dlg.m_iAnalysisType == 2 ) //г
			strFileNamestrDyaOut = strFilePath+".dynOutH";
		else if( dlg.m_iAnalysisType == 3 ) //׷
			strFileNamestrDyaOut = strFilePath+".dynOutE";
		else if( dlg.m_iAnalysisType == 4 ) //ȫ׷
			strFileNamestrDyaOut = strFilePath+".dynOutR";
		else if( dlg.m_iAnalysisType == 5 )//ˮ˨׷
			strFileNamestrDyaOut = strFilePath+".dynOutW";
		else if( dlg.m_iAnalysisType == 6 )//ʱ̷
			strFileNamestrDyaOut = strFilePath+".dynOutT";
		else
			return;


		//ڽļдģ
		//2007.04.29 lyf ޸Ľж޷鿴BUG
		//WriteDataToPSAFile(m_listPipeUnit,m_GlobalData,strFileNamestrRst,strAutoPSAVersion,strAutoPSARevision,gMaterialCon);

		OutMsg( GetResStr(IDS_DIS_DYNAMIC_FINISHED) );
		CPipeFEM StaticAnalysis;
		StaticAnalysis.CalcDyn(gstrMatPath.GetBuffer(20),gstrSpringPath.GetBuffer(20),
			strFileNameCmp.GetBuffer(20),strFileNameSta.GetBuffer(20),
			strFileNamestrRst.GetBuffer(20),strFileNamestrDya.GetBuffer(20),
			strFileNamestrDyaOut.GetBuffer(20),gRefInfoCon);
		OutMsg( GetResStr(IDS_DIS_BEGIN_DYNAMIC_ANALYSIS) );

		CString strTemp;
		strTemp.Format(GetResStr(IDS_SPRING_SHOW_RESULTS),strFileNamestrDyaOut);
		OutMsg(strTemp);
		CAnalysisResult dlg;
		dlg.m_strFileName = strFileNamestrDyaOut;
		dlg.DoModal();
		strTemp.Format(GetResStr(IDS_DIS_SHOW_FILE_SUCCEED),strFileNamestrDyaOut);
		OutMsg(strTemp);
	}
	
	// TODO: Add your command handler code here
	
}