#include "stdafx.h"
#include "AutoPSA.h"
#include "FileDialogEx.h"

#include "AutoPSAINDoc.h"
#include "AutoPSAINView.h"
#include "AutoPSA.h"
 
#include "MainFrm.h"
#include "CntrItem.h"
#include <fstream.h>
#include <math.h>
#include <IOMANIP.H>
#include "AutoPSAInTabView.h"
#include "ChildINFrm.h"
#include "math.h"
#include "TabPage1.h"
#include "TabPage2.h"
#include "TabPage3.h"

#include "psainterface.h"
#include "getpropertyofmaterial2.h"
#include "PipeStruct/OutFunction.h"
#include "AnalysisResult.h"
#include "DrawInView.h"
#include "user.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




void CAutoPSAInDoc::PreCloseFrame(CFrameWnd *pFrameArg)
{
	ASSERT_VALID(this);
	ASSERT_VALID(pFrameArg);

	// turn off redraw so the user doesn't see the deactivation happening
	BOOL bSetRedraw = FALSE;
	if (pFrameArg->GetStyle() & WS_VISIBLE)
	{
		pFrameArg->SendMessage(WM_SETREDRAW, (WPARAM)FALSE);
		bSetRedraw = TRUE;
	}

	// deactivate any inplace active items on this frame
	CRichEditView* pView= GetView();
	if(pView!=NULL && pView->IsKindOf(RUNTIME_CLASS(CRichEditView)))
	{
		pView->m_lpRichEditOle->InPlaceDeactivate();
	}
	POSITION pos = GetStartPosition();
	CRichEditCntrItem* pItem;
	while (pos != NULL)
	{
		pItem = (CRichEditCntrItem*) GetNextClientItem(pos);
		if (pItem == NULL)
			break;
		ASSERT(pItem->IsKindOf(RUNTIME_CLASS(CRichEditCntrItem)));
		pItem->Close();
	}
	// turn redraw back on
	if (bSetRedraw)
		pFrameArg->SendMessage(WM_SETREDRAW, (WPARAM)TRUE);	
}

BOOL CAutoPSAInDoc::IsModified()
{
	POSITION pos=GetFirstViewPosition();
	BOOL flag=FALSE;
	CView* pView;
	while(pos)
	{
		pView=this->GetNextView(pos);
		if(pView->IsKindOf(RUNTIME_CLASS(CAutoPSAINView)))
		{
			flag=TRUE;
			break;
		}
	}
	if(flag)
		return ((CAutoPSAINView *)pView)->GetRichEditCtrl().GetModify();
	return FALSE;
}

COleClientItem* CAutoPSAInDoc::GetPrimarySelectedItem(CView *pView)
{
	if(pView->IsKindOf(RUNTIME_CLASS(CRichEditView)))
		return ((CRichEditView*)pView)->GetSelectedItem();
	return NULL;
}

void CAutoPSAInDoc::OnViewFormview() 
{
	// TODO: Add your command handler code here
//	::m_Combo.EnableWindow(FALSE);
	CView * pView=GetActiveView(),*pView1;
	if(pView!=NULL && pView->IsKindOf(RUNTIME_CLASS(CAutoPSAInTabView)))
		return;
	POSITION  pos;
	BOOL flag;
	CPipeUnitData * pPipeUnit;

	//ͼͼΪͼʱϢԶ
	CMainFrame* mainfrm = (CMainFrame*)::AfxGetApp()->m_pMainWnd;
	if(mainfrm->m_wndOutput.IsWindowVisible())
	{
		mainfrm->m_wndOutput.ShowWindow(SW_HIDE);
		mainfrm->RecalcLayout();
	}


	//ͼͼ
	pos=this->GetFirstViewPosition();
	flag=FALSE;
	while(pos)
	{
		pView1=this->GetNextView(pos);
		if(pView1->IsKindOf(RUNTIME_CLASS(CDrawInView)))pView1->SendMessage(WM_INFDLG_CLOSE);
		if(pView1->IsKindOf(RUNTIME_CLASS(CAutoPSAInTabView)))
		{pView=pView1;//break;
		}
	}

	CMDIChildWnd* pWnd=(CMDIChildWnd*)pView->GetParentFrame();
	pWnd->ActivateFrame();


}

void CAutoPSAInDoc::OnUpdateViewFormview(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CView* pView=GetActiveView();
	if(pView && pView->IsKindOf(RUNTIME_CLASS(CAutoPSAInTabView)))
		pCmdUI->SetRadio(TRUE);
	else 
	{
		pCmdUI->SetRadio(FALSE);
	
		DeleteLastPipeUnit(m_listPipeUnit,this);
	}
}

void CAutoPSAInDoc::OnViewRichview() 
{

	DeleteLastPipeUnit(m_listPipeUnit,this);//ɾͶӰȫΪĵԪ2007-04-23lyf

	OnFileSave();

	CView * pView,*pView1;
	POSITION pos;
	pos=this->GetFirstViewPosition();
	while(pos!=NULL)
	{
		pView1=this->GetNextView(pos);
		if(pView1->IsKindOf(RUNTIME_CLASS(CDrawInView)))pView1->SendMessage(WM_INFDLG_CLOSE);
		if(pView1->IsKindOf(RUNTIME_CLASS(CAutoPSAINView)))
		{
			pView=pView1;//break;
		}
	}
	CMDIChildWnd* pWnd=(CMDIChildWnd*)pView->GetParentFrame();
	pWnd->ActivateFrame();
	
	//֮ĵ
	if(GetPathName()!="")
	{
		CFile * pFile=new CFile(GetPathName(),CFile::modeRead);
		CArchive ar(pFile,CArchive::load);
		Serialize(ar);
		ar.Close();
		pFile->Close();
		delete pFile;
		SetModifiedFlag(FALSE);
	}

 }

void CAutoPSAInDoc::OnUpdateViewRichview(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
	CFrameWnd* pFrameWnd=((CFrameWnd*)AfxGetMainWnd())->GetActiveFrame();
	CView* pView=(pFrameWnd)->GetActiveView();
	if(pView && pView->IsKindOf(RUNTIME_CLASS(CAutoPSAINView)))
		pCmdUI->SetRadio(TRUE);
	else pCmdUI->SetRadio(FALSE);
}


//extern RightTr(CString &StrText);
//chengbailian 2004.1.8
//ַȡi(ַPSAļиʽ,ԡ,Ÿ)
double GetAt(CString StrText,int i)
{
	int start=0,end=0;
	CString str;
	StrText.TrimLeft();
	StrText.TrimRight();
	if(i>1)
	{
		for(int index=1;index<=i-1;index++)
		{
			start=StrText.Find(',',start+1);
		}
		end=StrText.Find(',',start+1);
		if(end!=-1)
			str=StrText.Mid(start+1,end-start-1);
		else
			str=StrText.Mid(start+1);
	}
	else
		str=StrText.Left(StrText.Find(',')+1);
	return atof(str);

}

//ַзȡi(ַPSAļиʽ)
double ReverseAt(CString StrText,int i)
{
	int start=0,sumnum=0;
	CString str;
	StrText.TrimLeft();
	StrText.TrimRight();
	while(start!=-1)
	{
		start=StrText.Find(',',start+1);
		sumnum++;
	}
	return GetAt(StrText,sumnum+1-i);
}
//end cbl

extern double GetNextNumeric(CString &StrText);


BOOL CAutoPSAInDoc::WriteListToFile(CString FileName)
{
	WriteDataToPSAFile(m_listPipeUnit,m_GlobalData,FileName,strAutoPSAVersion,strAutoPSARevision,gMaterialCon);
	return TRUE;
}

CString GetNewVersionFileName(CString OldFileName)
{
	CString AutoNewFileName;
		while(OldFileName.Right(1)!=".")
					   OldFileName=OldFileName.Left(OldFileName.GetLength()-1);
		AutoNewFileName=OldFileName.Left(OldFileName.GetLength()-1)+"new.in";
    return AutoNewFileName;
}

extern  int VerdictOldFile(CString filename);  //жļǷΪϸʽ
BOOL CAutoPSAInDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	//chengbailian 2003.12.17
	//رմͬļ
	POSITION pos=CAutoPSAApp::m_SpInDocTemplate->GetFirstDocPosition();
	CDocument *pDoc;
	while(pos!=NULL)
	{
		pDoc=CAutoPSAApp::m_SpInDocTemplate->GetNextDoc(pos);
		if(pDoc->GetPathName() == lpszPathName)
		{
			pDoc->OnCloseDocument();
			
		}
	}
	//end cheng

	
	// TODO: Add your specialized creation code here
	//AfxMessageBox(lpszPathName);
	CPipeUnitData * pPipeUnit;
	POSITION tempPos;

//ȥļֻ
	DWORD dwFileAttr;
	BOOL bPointFileValidate = FALSE;
	dwFileAttr=GetFileAttributes(lpszPathName);
	if(dwFileAttr!=0xFFFFFFFF)
		SetFileAttributes(lpszPathName,FILE_ATTRIBUTE_NORMAL);

	((CMainFrame*)AfxGetMainWnd())->m_wndOutput.m_FlatTabCtrl.SetCurSel(0);
	((CMainFrame*)AfxGetMainWnd())->m_wndOutput.SelectTabView(0);
	((CMainFrame*)AfxGetMainWnd())->ShowControlBar(&((CMainFrame*)AfxGetMainWnd())->m_wndOutput,TRUE,FALSE);
	((CMainFrame*)AfxGetMainWnd())->m_wndOutput.UpdateWindow();

	CString strInfo;
	
	int iIndex;
	CString strText,strTemp;
	strText = lpszPathName;
	iIndex = strText.ReverseFind('.');
	strText=strText.Mid(iIndex);
	strText.MakeLower();

	if(strText==".psa")
	{
		BOOL bRT = false;
		
		bRT = ReadPSAFileToList( m_listPipeUnit,m_GlobalData,lpszPathName,gRefInfoCon);
		if (!CRichEditDoc::OnOpenDocument(lpszPathName))
			return FALSE;
		
		if(bRT == false)
		{
			ReadFileOutMsg(strInfo);
			//ʾļ
			CString strWinDir;
			::GetWindowsDirectory(strWinDir.GetBuffer(_MAX_PATH),_MAX_PATH);
			strWinDir.ReleaseBuffer();
			strWinDir+=_T("\\");
			::WinExec(T2A((LPTSTR)(LPCTSTR)(strWinDir+_T("notepad.exe  ")+lpszPathName)),SW_SHOW);
			return FALSE;
		}
		else
		{
			strInfo.Format( GetResStr( IDS_READ_FILE_SUCCEED ),lpszPathName);
			ReadFileOutMsg(strInfo);
			if(bReadError)
			{
				CFile * pFile=new CFile(lpszPathName,CFile::modeRead);
				CArchive ar(pFile,CArchive::load);
				Serialize(ar);
				ar.Close();	
				pFile->Close();
				delete pFile;
			}
			if(m_listPipeUnit->GetCount()>0)
				m_PipeUnitData=m_listPipeUnit->GetHead();
			else
				return FALSE;
		}	
	}
	else
	{
		strInfo.LoadString(IDS_UNKNOWFORMAT);
		AfxMessageBox(strInfo);
		ReadFileOutMsg(strInfo);
		return FALSE;
	}
	
	
	SetModifiedFlag(FALSE);
	return TRUE;
}

void CAutoPSAInDoc::OnFileSaveAs()
{	
	CString Filter,dlgTitle;
	CString DefFileName,FileName;
	CPipeUnitData * pPipeUnit;
	//Modified־
	POSITION pos;
	pos=m_listPipeUnit->GetHeadPosition();
	
	m_nNewFile++;
	DefFileName.Format(IDS_ORIGINALDATAFILE,m_nNewFile);
	Filter.Format(IDS_PSASAVEFILETYPE);
	CFileDialogEx dlg(FALSE,"*.psa",(LPCTSTR)DefFileName,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,(LPCTSTR)Filter);
	dlg.m_ofn.lpstrInitialDir=gsPSAOutFilePath;
	dlgTitle.Format(IDS_SAVEASDLGTITLE);
	dlg.m_ofn.lpstrTitle=dlgTitle;
	if(dlg.DoModal()==IDOK)
	{
		FileName=dlg.GetPathName();
		gsPSAOutFilePath=::GetFilePath(dlg.GetPathName());
		::m_strFileNameIn = FileName;
	}
	else
	{
		m_nNewFile--;
		return;
	}
	
	
	
	OnSaveDocument(FileName);//едļ
	pos=m_listPipeUnit->GetHeadPosition();
	while(pos!=NULL)
	{
		pPipeUnit=m_listPipeUnit->GetNext(pos);
		pPipeUnit->m_bModified=FALSE;
	}
	SetPathName(FileName,TRUE);
	SetModifiedFlag(FALSE);
	
	UpdateAllViews(NULL);
	
}

/*
ʱ䣺04.2.23
ߣchengbailian
: Ԫĸ
ֵ:Ԫĸ
*/

int GetUnitCount(CString FileName)
{
	ifstreamex fin;
	fin.open(FileName);
	double temp;
	char A;
	int n;
	int tempNC;
	int NodeNumIn=0;
	CString strText;

	//ǰ
	for(int i=0;i<4;i++)
	{
		fin.getline(strText.GetBufferSetLength(255),255);
		strText.ReleaseBuffer();
	}

	//ļʽԵ£
	while(!fin.eof())
	{
		fin.getline(strText.GetBufferSetLength(255),255);
		strText.ReleaseBuffer();

		//ʱļһвŻ
		if(strText.IsEmpty() && fin.eof())
			break;
		tempNC = GetAt(strText,1);
		if(tempNC==85)
		{
			n = GetAt(strText,2);
			for(i=0;i<n;i++)
			{
				fin.getline(strText.GetBufferSetLength(255),255);
				strText.ReleaseBuffer();
			}
		}
		else if(tempNC==10)
		{
			while(!fin.eof())
			{
				fin.getline(strText.GetBufferSetLength(255),255);
				strText.ReleaseBuffer();

				//ʱļһвŻ
				if(strText.IsEmpty() && fin.eof())
					break;

				tempNC = GetAt(strText,1) ;

				switch (tempNC)
				{
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 0:
					NodeNumIn++;
					break;
				case 85:
					n = GetAt(strText,2);
					for(i=0;i<n;i++)
					{
						fin.getline(strText.GetBufferSetLength(255),255);
						strText.ReleaseBuffer();
					}
					break;
				default:
					break;
				}

				
			}
		}
	}
	fin.close();
	return NodeNumIn;

}


/*
ʱ:04.2.23
:chengbailian
ܣ.pesļжݷӦ
ֵ:true.pesļеļеĵԪƥ ;false:
*/
BOOL CheckFullInfoFile(int nUnitNumer,CString strInfoFileName,NodeNumList *pListNodeNum,DensityList *pListDensity,SpringIndexList *pListSpringIndex,SequenceNumberList *pListSequenceNumber)
{
	ifstreamex fpes;
	fpes.open(strInfoFileName,ios::binary);
	float ftemp[OBLIGATEPES];//Ԥռ
	int nInfoUnitNume=0;

	NodeNum* pNodeNum;
	DensityData *pDensityData;
	SpringIndex *pSpringIndex ;
	SequenceNumberData *pSequenceNumberData;

	while(!fpes.eof())
	{
		pNodeNum = new NodeNum;
		pDensityData = new DensityData;
		pSpringIndex = new SpringIndex;
		pSequenceNumberData = new SequenceNumberData;
		READ14(fpes,pNodeNum->m_nNodeNumFrom,pNodeNum->m_nNodeNumTo,
			pDensityData->dbPipeDensity,pDensityData->dbFluidDensity,
			pDensityData->dbPipeInsulationThickness,pDensityData->dbPipeInsulationThickness2,
			pDensityData->dbPipeInsulationThickness3,pDensityData->dbInsulationDensity,
			pDensityData->dbInsulationDensity2,pDensityData->dbInsulationDensity3,
			pSpringIndex->SpringTypeIndex,pSequenceNumberData->nSequenceNumber,pDensityData->m_fSlopeMeetSectNodeCount,ftemp);
		if(pDensityData->m_fSlopeMeetSectNodeCount <0.000001)//ĬֵΪ1
			pDensityData->m_fSlopeMeetSectNodeCount = 1;
		 
		//ģнڵŴ20000ʱʾϢ2007.05.09 lyf
		if( (pNodeNum->m_nNodeNumFrom>20000 || pNodeNum->m_nNodeNumTo>20000) && !fpes.eof() )
		{	
			CString temp_str;
			temp_str.Format( IDS_OVER_RANGE  );
			AfxMessageBox(temp_str);
			fpes.close();
			::DeleteFile(strInfoFileName);
			delete pNodeNum;
			delete pDensityData;
			delete pSpringIndex;
			delete pSequenceNumberData;
			return 0;
		}//
		
		//ģнڵļʱʾϢ2007.05.09 lyf
		if( !fpes.good() && !fpes.eof() )
		{
			CString temp_str;
			temp_str.LoadString(IDS_NODEFILE_ERROR);
			AfxMessageBox(temp_str);
			fpes.close();
			::DeleteFile(strInfoFileName);
			delete pNodeNum;
			delete pDensityData;
			delete pSpringIndex;
			delete pSequenceNumberData;
			return 0;
		}//

		if(!fpes.eof())
		{
			nInfoUnitNume++;
			if(pListNodeNum)
				pListNodeNum->AddTail(pNodeNum);
			else
				delete pNodeNum;
			if(pListDensity)
				pListDensity->AddTail(pDensityData);
			else 
				delete pDensityData;
			if(pListSpringIndex)
				pListSpringIndex->AddTail(pSpringIndex);
			else
				delete pSpringIndex;
			if(pListSequenceNumber)
				pListSequenceNumber->AddTail(pSequenceNumberData);
			else
				delete pSequenceNumberData;
		}

	}
		delete pNodeNum;
		delete pDensityData;
		delete pSpringIndex;
		delete pSequenceNumberData;
	fpes.close();
	if(nUnitNumer == nInfoUnitNume)
		return 1;
	return 1;//2007.05.10 lyf
}

void CAutoPSAInDoc::OnUpdateDynamicAnalisis(CCmdUI* pCmdUI)
{
	CString strFilePath,strFileNamestrstaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrstaOut = strFilePath+".staOut";
	pCmdUI->Enable(::FileExists(strFileNamestrstaOut));
}

//ģ̬
void CAutoPSAInDoc::OnUpdateModal(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutM";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}

//г
void CAutoPSAInDoc::OnUpdateHarmic(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutH";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}

//׷
void CAutoPSAInDoc::OnUpdateEarthquake(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutE";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}

//ȫ׷
void CAutoPSAInDoc::OnUpdateReliefLoads(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutR";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}


//ˮ˨׷
void CAutoPSAInDoc::OnUpdateWaterHammer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutW";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}


//ʱ̷
void CAutoPSAInDoc::OnUpdateTrans(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutT";
	pCmdUI->Enable(::FileExists(strFileNamestrDyaOut));
}

//ģ̬
void CAutoPSAInDoc::OnModal() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutM";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}

//г
void CAutoPSAInDoc::OnHarmic() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutH";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}

//׷
void CAutoPSAInDoc::OnEarthquake() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutE";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}

//ȫ׷
void CAutoPSAInDoc::OnReliefLoads() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutR";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}


//ˮ˨׷
void CAutoPSAInDoc::OnWaterHammer() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutW";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}


//ʱ̷
void CAutoPSAInDoc::OnTrans() 
{
	// TODO: Add your command update UI handler code here
	CString strFilePath,strFileNamestrDyaOut;
	strFilePath=::GetFilePath(::m_strFileNameIn);
	strFilePath+="\\";
	strFilePath+=::GetFileTitle(::m_strFileNameIn);
	strFileNamestrDyaOut = strFilePath+".dynOutT";
	CAnalysisResult dlg;
	dlg.m_strFileName = strFileNamestrDyaOut;
	dlg.DoModal();
}

